﻿using System;
using System.Windows.Browser;
using System.Windows.Controls;
using System.Windows.Media.Imaging;
using System.Windows;

namespace SampleGame
{
    public class PersonInfo
    {
        public int TID;
        public string displayName;
        public string profileUrl;
        public string thumbnailUrl;
    }

    public class SocialData
    {
        public static ScriptObject owner = null;
        public static string ownerData = null;

        public static ScriptObject friends = null;
        public static ScriptObject friendsData = null;

        public static PersonInfo ownerInfo;
        public static PersonInfo[] friendInfo;

        public SocialData()
        {

        }

        public static bool Pulse()
        {
            if (owner == null)
            {
                owner = HtmlPage.Window.Eval("document.getElementById(\"owner_info\")") as ScriptObject;
            }
            else if (ownerData == null)
            {
                ownerData = owner.GetProperty("ownerData") as string;
            }
            else if (friends == null)
            {
                friends = HtmlPage.Window.Eval("document.getElementById(\"friends_info\")") as ScriptObject;
            }
            else if (friendsData == null)
            {
                friendsData = friends.GetProperty("friendsData") as ScriptObject;
            }
            else
            {
                #region 내 정보 저장
                ownerInfo = new PersonInfo();
                string[] info = ownerData.Split('#');
                ownerInfo.TID = Int32.Parse(info[0]);
                ownerInfo.displayName = info[1];
                ownerInfo.profileUrl = info[2];
                ownerInfo.thumbnailUrl = info[3];

                MessageBox.Show("내 정보_ID - " + ownerInfo.TID.ToString() + "\n내 정보_이름 - " + ownerInfo.displayName + "\n내 정보_profileUrl - " + ownerInfo.profileUrl + "\n내 정보_thumbnailUrl - " + ownerInfo.thumbnailUrl);
                #endregion

                #region 일촌 정보 저장
                double fNum = (double)friendsData.GetProperty("length");
                int numFriends = (int)fNum;

                friendInfo = new PersonInfo[numFriends];

                string str = "";
                for (int i = numFriends - 1; i >= 0; i--)
                {
                    friendInfo[i] = new PersonInfo();
                    str = friendsData.Invoke("pop") as string;
                    info = str.Split('#');
                    friendInfo[i].TID = Int32.Parse(info[0]);
                    friendInfo[i].displayName = info[1];
                    friendInfo[i].profileUrl = info[2];
                    friendInfo[i].thumbnailUrl = info[3];

                    MessageBox.Show("친구 정보_ID - " + friendInfo[i].TID.ToString() + "\n친구 정보_이름 - " + friendInfo[i].displayName + "\n친구 정보_profileUrl - " + friendInfo[i].profileUrl + "\n친구 정보_thumbnailUrl - " + friendInfo[i].thumbnailUrl);
                }
                #endregion

                return true;
            }
            return false;
        }
    }
}